<?php

global $HTPASSWD_CODE_DIR;
require($HTPASSWD_CODE_DIR . "/HtPasswd.php");

class PmWiki_UserDB extends Abstract_UserDB {

  var $ht_obj;
  
  function PmWiki_UserDB() {
    global $HTPASSWD_FILE;

    $this->ht_obj = new HtPasswd($HTPASSWD_FILE);

    $this->nobody = new NobodyUser();
    $this->everybody = new EverybodyUser();
    $this->loggedIn = new LoggedInUser();
  }
  
  function getUidList() {
    $uidList = $this->ht_obj->GetAllUsers();
        
    array_push($uidList, $this->nobody->getUid());
    array_push($uidList, $this->everybody->getUid());
    array_push($uidList, $this->loggedIn->getUid());
    
    sort($uidList);
    return $uidList;
  }
 
  function getUserByUsername($username, $level=0) {
    if (!strcmp($username, $this->nobody->getUsername())) {
      return $this->nobody;
    } else if (!strcmp($username, $this->everybody->getUsername())) {
      return $this->everybody;
    } else if (!strcmp($username, $this->loggedIn->getUsername())) {
      return $this->loggedIn;
    }
    
    $user = new PmWiki_User($this->ht_obj);
    $user->loadByUsername($username);
    return $user;
  }
  
  function getUserByUid($uid) {
    return $this->getUserByUsername($uid);
  }
  
  function getCurrentUsername() {
    if ($_SESSION['username']) {
      return $_SESSION['username'];
    } else {
      return NULL;
    }
  }

}

?>
